#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef MSDOS
#include <alloc.h>
#endif

#include "ipincl.h"

static char convertpixel(int);
static int Ocean = 7;  /*  this should be done by an alias lookup  MRL */

/* Get the color value for the country/region whose code is "val". */
static char convertpixel (int val)
{
  int i;

  if (val == 0) return (Ocean);   /*  0 in the map is an ocean  */
  if (val == -1) return (0);  /*  -1 in map is the void  */
  for (i=0; i<Numregions+Numcountries; i++)
    if (Country_list[i].code == val)
      return(Country_list[i].color);
  return (-1); /* There is no region/country with this code */
}


void makecmap (char *filename, int maxx, int maxy)
 {
 FILE *fptr, *optr;
 int i,j;
 char fname[80];
 char oname[80];
 int *line;
 char *pix;

 if ((line = malloc (2*550)) == NULL)
   GSelog (-1, "Not enough memory to make color map.\n");
 if ((pix = malloc (550)) == NULL)
   GSelog (-1, "Not enough memory to make color map.\n");
 strcpy (fname, filename);
 strcpy (oname, filename);
 strcat (fname, ".img");
 strcat (oname, ".clr");
 if ((fptr = GSopen (fname, "rb")) == NULL)
   GSelog (-1, "Bad input file name |%s|.\n", fname);

 if ((optr = GSopen (oname, "wb")) == NULL)
   GSelog (-1, "Bad output file name |%s|\n.", oname);

 for (i=0; i <  maxy; i++)
   {
   fread (line, sizeof (int), maxx, fptr);
   for (j=0; j < maxx; j++)
     pix[j] = convertpixel (line[j]);
   fwrite (pix, sizeof (char), maxx, optr);
   } 
 fclose (fptr);
 fclose (optr);
 }
