#include <stdio.h>
#include "ipincl.h"

boolean WarnedNotToCoverWin = FALSE; /*--- Set to TRUE when the "dump" window
                                           is used to warn the user not to cover
                                           the application window during a screen
                                           dump. Reset when the user acknowledges
                                           this. Not used in DOS, since DOS
                                           screen can't be overdrawn. ---*/

int Savemsg;         /* Save help message context */
int ParmSavemsg;
int QuickStartSavemsg;
int MapSelectSavemsg;

/* Configuration variables and default initializations */
BigString Listname = "country.gaf"; /* country name list file */

int AlertNumber = 0;

boolean Use_bstore = FALSE;

BigString DumpFileName = "";

boolean DumpSuccess = FALSE;

boolean DumpResultsActive = FALSE;      /* TRUE iff results of dumpscreen are
                                           showing in alert window */
boolean DumpWinActive = FALSE;

boolean QuitWinActive = FALSE;

boolean TutorEntry = FALSE;
		/* if true, then we are entering from Authorware tutorial */
boolean Tutorfile = FALSE;
		/* if true, then we are entering from Authorware tutorial and
	   there is a previous file to restore.*/
boolean Drag_Used = FALSE;      /* Set by dragrect functs. Checked by walkthru */
boolean MapSelect = FALSE;  /* TRUE iff selection window is active */
boolean HelpWinActive = FALSE; /* TRUE iff help window is active */
boolean QuickStartActive = FALSE;  /* TRUE iff QuickStart Screen is active */
boolean InWalkThru = FALSE; /* TRUE iff the walk thru tutorial function is active */
boolean StartWalkThru = FALSE; /* TRUE iff command line switch to start walkthru is set */
boolean SetFertActive = FALSE;     /* TRUE iff the setfert window is up */
boolean SetLifeExActive = FALSE;   /* TRUE iff the setlifeex window is up */
boolean SetMigActive = FALSE;      /* TRUE iff the setmig window is up */

GraphicsFileType GraphFileFmt = NO_FILE; /* if NO_FILE, then screen dumps not allowed, */
                             /* else this holds file format for screen dumps */

BigString Datapath = "/dbase/";   /* path to country database */
BigString Listpath = "/dbase/";   /* path to country list file */
BigString Infopath = "/info/";    /* path to info database */
BigString Imagepath = "/images/";    /* path to picture files */

BigString Home;  /* Path to the directory that contains intlpop.exe.
		 Computed from argv[0]. */
BigString InterfaceFile = "intlpop.inf"; /* user interface file */
BigString CountryFile; /* Country map file (with full path name) */
BigString RegionFile; /* Region map file (with path) */
BigString ListFile; /* country name list file (with path) */
BigString IntroFile; /* Quick start instruction picture file (with path) */
BigString VersionFile;
BigString SaveFile = "ip_000.sav";    /* user save file */
BigString Helpfile; /* Space to hold the path and name of a help file */
BigString Introfilename; /* Quick start instruction picture file (w/o path) */
BigString Countryfilename; /* Country map file (without path) */
BigString Regionfilename; /* Region map file (without path) */
GSPicture Countrypic;  /* Picture descriptor structures */
GSPicture Regionpic;
int MapScale = 4;  /* Size of a pixel for country map, initially 4X4. */
int Xorx, Xory, Xorwd, Xorht;  /* Specs for Xor box on regions map */

/* This flag is set to TRUE iff a floating point unit is present */
boolean HasFPU = FALSE;   /* This boolean must be set to 0 or 1 during program initialization */

Clist *Country_list; /* The array of country/region info */
int Numregions;    /* Number of regions/countries in world -- */
int Numcountries;  /*   as indicated by country_gaf.  For declaring space. */
int Realnumregions;    /* Actual number of regions/countries in world -- */
int Realnumcountries;  /*   as found in the database */
int Picklistpage;  /* Current Page Being Viewed on the pick list */
int Pickno;   /* Used for picking country/regions (index into Country_list) */

BigString searchstring;   /* The country/region a user types in at keyboard */

int ScrollPicknumpages;  /* Total number of pages on the country/region scroll list */

int Cdisp; /* which of the two country displays is current */
CountryInfo Country[NUM_DISPLAYS];  /* Read-in data for a country */

/* The country display state descriptor */
DisplayType Display[NUM_DISPLAYS] =
  {{OFF, FALSE, FALSE, FALSE, FALSE, -1},
   {OFF, FALSE, FALSE, FALSE, FALSE, -1}};

char *Displayname[NUM_DISPLAYS] = {"top", "bottom"};
char *TFRname[NUM_DISPLAYS] = {"toptotalfert", "bottomtotalfert"};
char *Lifexname[NUM_DISPLAYS] = {"toplifeexp", "bottomlifeexp"};
char *Migname[NUM_DISPLAYS] = {"topmig", "bottommig"};
char *Infowinname[NUM_DISPLAYS] = {"topinfo", "bottominfo"};
char *Birthwinname[NUM_DISPLAYS] = {"topbirth", "bottombirth"};
char *Deathwinname[NUM_DISPLAYS] = {"topdeath", "bottomdeath"};
char *Infantwinname[NUM_DISPLAYS] = {"topinfant", "bottominfant"};

/* This (huge!) structure stores the current state of the simulation.
   For every step of all three simulations in each display, all
   necessary information about cohort population, birth and death
   rates is stored. */
IPStatetype *IPState[NUM_DISPLAYS][NUM_SIMS];

IPsaveyear_t *IPsaveyear[NUM_DISPLAYS][NUM_SIMS];

/* These next two arrays contain the distribution for migrants by sex
and cohort.  The number indicate migrants of that catagory out of
a total of 1000 migrants.  The total of all 34 numbers should be 1000. */
int Mmig[17] = {18, 40, 32, 36, 50, 67, 49, 36, 32,
		31, 23, 13,  9,  9,  5,  0,  0};
int Fmig[17] = {16, 44, 39, 50, 66, 88, 66, 44, 38,
		33, 22, 17, 11, 11,  5,  0,  0};

