/***********************************************************************
International Population module scroll pick list functions
***********************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "ipincl.h"

#if 0
static int sclistposition;         /* y value of the sclistbutton relative to window */
static int sclistht;               /* number of pixels for sclist (scroll) button */
static int sclistrange;            /* num pixels over which sclistbutton may move */
#endif
#if 0
ButtonStatusType UpArrowStatus;
ButtonStatusType DnArrowStatus;
#endif
static int CurrSlot;				/* updated during drag through list */
static int OldSlot;

GSlistHandle gPickList; 
GSsclistHandle gThumb; /* Added. JBR */
/* 
	Rewritten with new picklist & sclist funcs.  JBR
*/

/*********************************************************************
 Display the current selection (Pickno) name
*********************************************************************/
void display_curr_selection(void)
{
  int x, y, wd, ht;
  GSColor color;
  BigString currentwindow;

  if (Pickno == -1)       /* If Pickno == -1 (nothing selected), return */
    return;

  /* Display the current selection (Pickno) name */
  GSgetcurrentwindowname(currentwindow);
  GSsetcurrentnamedwindow("map");
  GSgetfieldrect("SNAMEBACK", &x, &y, &wd, &ht, &color);
  GSsetcolor(color);
  GSwfillrect (x, y, wd, ht);
  GSgetfieldrect("SNAME", &x, &y, &wd, &ht, &color);
  GSsetfont (LARGE);
  GSsetcolor(color);
  GSwwritemsg (x, y+LARGE,  Country_list[Pickno].name);
  GSsetcurrentnamedwindow(currentwindow);
}

/************************************************************************
  Draw the map and scroll selection window
************************************************************************/
void draw_selection_window(void)
{
  int fx, fy, fwd, fht;
  GSColor fcolor;
  int x, y, wd, ht;
  GSColor color;
  BigString currentwindow;

  GSgetcurrentwindowname(currentwindow);

  if (!InWalkThru)
    if (TutorEntry)
      GSdisablebutton("root", "glossary", DRAW);
    else
      GSdisablebutton("root", "file", DRAW);

  GSsetcurrentnamedwindow("map");

  GScharfunc("keyfunc");
  GSgetfieldrect("scrollpickfield", &fx, &fy, &fwd, &fht, &fcolor);
  GSsetcolor (fcolor);
  GSwfillrect(fx, fy, fwd, fht);

  GSgetfieldrect("searchtext", &fx, &fy, &fwd, &fht, &fcolor);
  GSsetcolor(fcolor);
  GSwfillrect(fx, fy, fwd, fht);

/*  GSgetfieldrect("scrollbarfield", &fx, &fy, &fwd, &fht, &fcolor);
  (void)drawscroll(fx, fy+sclistposition, fwd, sclistht);*/
  GSdrawsclist(gThumb);
/*  drawuparrow(UpArrowStatus, FALSE);
  drawdownarrow(DnArrowStatus, FALSE);*/


  display_searchstring();

  display_curr_selection();

  GSgetfieldrect("MSCALEBACK", &x, &y, &wd, &ht, &color);
  GSsetcolor(color);
  GSwfillrect(x, y, wd, ht);
  GSgetfieldrect("MSCALE", &x, &y, &wd, &ht, &color);
  GSsetfont (LARGE);
  GSsetcolor(color);
  GSwwriteint(3, x, y+LARGE, MapScale);
  GSgetfieldrect("SMAP", &x, &y, &wd, &ht, &color);
  GSsetcolor(color);
  GSwfillrect(x, y, wd, ht);
  GSwdrawpict(&Regionpic, x, y, wd, ht, 0, 0, 1, code2color);
  GSdrawxorbox(Xorx+x, Xory+y, Xorwd, Xorht);
  GSgetfieldrect("LMAP", &x, &y, &wd, &ht, &color);
  GSsetcolor(color);
  GSwfillrect(x, y, wd, ht);
  GSwdrawpict(&Countrypic, x, y, wd, ht, 2*Xorx, 2*Xory, MapScale, code2color);

  GSsetcurrentnamedwindow(currentwindow);
}


/**************************************************************************
   Pop up a list from which the user can select a country to appear in
   one of the display windows.
   The list is scrollable.  Initialize pick list functions and scrolling
   parameters (such as height of scroll button).
***************************************************************************/
boolean scrollselectcountry(void)
{
  GSColor bcol, ulcol, lrcol;
  int i;
  int numItems;
  
  strcpy(searchstring, "");     /* initialize to null */

  ScrollPicknumpages = 202-PICKSPERSCROLLPAGE+1;

  for (i=0; i<(Realnumregions+Realnumcountries); i++)
	if (!Country_list[i].display)
	  ScrollPicknumpages--;
 
  numItems = ScrollPicknumpages +  PICKSPERSCROLLPAGE - 1;

  GSdrawnamedwindow("map", FALSE, POPUP);
  GSsetactivenamedwindow("root");
  GSsetactivenamedwindow("message");

  GSgetfieldrect("sclistbutton", NULL, NULL, NULL, NULL, &bcol);
  GSgetfieldrect("sclistupleft",NULL, NULL , NULL, NULL, &ulcol);
  GSgetfieldrect("sclistlowright", NULL, NULL, NULL, NULL, &lrcol);

  Picklistpage = 1;

  GSsclistsetup("map", 
					"scrollcountry", 
					1, "scrollpicklabel",
					0, 0, 
					JUST_LEFT, 
					scrollpicklabel_func,
					scrollpicktext_func, 
					scrollpickin_func,
					scrollpickout_func, 
					scrollpickclick_func,
					"scrollbar", bcol, ulcol, lrcol, numItems,
					0, NULL, /* was adjust_for_scroll */ 
					"UpArrow", "DnArrow", 
					&gPickList, &gThumb);

  draw_selection_window();

  return(TRUE);
}

/**************************************************************************
Dismantle scrolling list.  (Added - JBR)
**************************************************************************/
void endselectcountry()
{
	GSdismantlesclist(gThumb);
}

/**************************************************************************
Return the index of the number'th displayable item
**************************************************************************/
int display_item_number(int number)
{
  int i=-1;
  int displaynumber=-1;

  while(displaynumber<number)
  {
    i++;
	if (Country_list[i].display)
      displaynumber++;
  }
  return i;
}


/**************************************************************************
 Return the label for the given slot.  "slot" is from the point of view
   of the list handler routines
**************************************************************************/
char *scrollpicklabel_func(int slot)
{
	return(Country_list[display_item_number(slot)].name);
}


/**************************************************************************
 Set the text attributes for a label on the pick list
**************************************************************************/
void scrollpicktext_func(GSlistHandle lh, int slot)
{
  int x, y, wd, ht;
  GSColor color;

  x = slot;  /* to make the compiler happy */
  GSgetfieldrect("SCROLLPICKLABEL", &x, &y, &wd, &ht, &color);
  GSsetfont(SMALL);
  GSsetcolor(color);
}


/**************************************************************************
What to do when cursor is inside the pick list
**************************************************************************/
void scrollpickin_func(int slot)
{
  int x, y, wd, ht;
  GSColor color;
  BigString currentwindow;

  CurrSlot = slot;
  if (CurrSlot != OldSlot)
  {
	/* Display country that mouse is over in CNAME field */
	OldSlot = CurrSlot;
	GSgetcurrentwindowname(currentwindow);
	GSsetcurrentnamedwindow("map");
	GSgetfieldrect("CNAMEBACK", &x, &y, &wd, &ht, &color);
    GSsetcolor(color);
	GSwfillrect (x, y, wd, ht);
	GSgetfieldrect("CNAME", &x, &y, &wd, &ht, &color);
	GSsetfont (LARGE);
    GSsetcolor(color);
	GSwwritemsg (x, y+LARGE,  Country_list[display_item_number(CurrSlot)].name);
	GSsetcurrentnamedwindow(currentwindow);
  }
}


/**************************************************************************
 What to do when cursor moves outside the pick list
 Nothing is done.
**************************************************************************/
void scrollpickout_func(void)
{
  int x, y, wd, ht;
  GSColor color;
  BigString currentwindow;

  /* display 'NONE' in CNAME field (NONE = mouse is not over any country)*/
  OldSlot = -1;
  GSgetcurrentwindowname(currentwindow);
  GSsetcurrentnamedwindow("map");
  GSgetfieldrect("CNAMEBACK", &x, &y, &wd, &ht, &color);
  GSsetcolor(color);
  GSwfillrect (x, y, wd, ht);
  GSgetfieldrect("CNAME", &x, &y, &wd, &ht, &color);
  GSsetfont (LARGE);
  GSsetcolor(color);
  GSwwritenamedmsg(x, y+LARGE, "ctynone");
  GSsetcurrentnamedwindow(currentwindow);
}


/**************************************************************************
 What to do when button clicks in the pick list
**************************************************************************/
void scrollpickclick_func(int slot)
{
  scrollpickin_func(slot);
  Pickno = display_item_number(CurrSlot);
  Drag_Used = TRUE;			/* walkthru checks this flag */

  display_curr_selection();

  GSdrawlistitem(gPickList, New, Highlight);
}


/**************************************************************************
 Process the dragrect in the country pick list
**************************************************************************/
boolean scrolldraggetcountry(int relx, int rely, DragStatusType status)
{
  GShandlelist(gPickList, relx, rely, status);
  return(TRUE);
}

/**************************************************************************
Scroll list down one line.
**************************************************************************/
boolean scrolldnline(void)
{
	GShandledownbutton(gThumb);
	return(TRUE);
}

/**************************************************************************
Scroll list up one line.
**************************************************************************/
boolean scrollupline(void)
{
	GShandleupbutton(gThumb);
	return(TRUE);
}

/**************************************************************************
Scroll list up by numpages lines.
**************************************************************************/
boolean scrollup(int numpages)
{
	GSsetsclistpos(gThumb, GSgetsclistpos(gThumb)-numpages, TRUE);
    Picklistpage -= numpages;
	return(TRUE);
	
}
/**************************************************************************
Scroll list down by numpages lines.
**************************************************************************/
boolean scrolldn(int numpages)
{
	GSsetsclistpos(gThumb, GSgetsclistpos(gThumb)+numpages, TRUE);
	return(TRUE);
	
}

/**************************************************************************
Drag rect function for scroll bar control.
**************************************************************************/
boolean scrollbar(int relx, int rely, DragStatusType status)
{
	GShandlesclist(gThumb, relx, rely, status);
	return TRUE;
}
